# Notes #
# Uninstall Does Not Require Admin
# Install May Require Admin
# Finding Installed Apps Requirs Admin



# Hide PowerShell Console [Script Ran Directly] #
Add-Type -Name Window -Namespace Console -MemberDefinition '
[DllImport("Kernel32.dll")]
public static extern IntPtr GetConsoleWindow();
[DllImport("user32.dll")]
public static extern bool ShowWindow(IntPtr hWnd, Int32 nCmdShow);
'
$consolePtr = [Console.Window]::GetConsoleWindow()
[Console.Window]::ShowWindow($consolePtr, 0)



# Press Keys #
$source = @"
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Runtime.InteropServices;
using System.Windows.Forms;
namespace KeyboardSend
{
    public class KeyboardSend
    {
        [DllImport("user32.dll")]
        public static extern void keybd_event(byte bVk, byte bScan, int dwFlags, int dwExtraInfo);
        private const int KEYEVENTF_EXTENDEDKEY = 1;
        private const int KEYEVENTF_KEYUP = 2;
        public static void KeyDown(Keys vKey)
        {
            keybd_event((byte)vKey, 0, KEYEVENTF_EXTENDEDKEY, 0);
        }
        public static void KeyUp(Keys vKey)
        {
            keybd_event((byte)vKey, 0, KEYEVENTF_EXTENDEDKEY | KEYEVENTF_KEYUP, 0);
        }
    }
}
"@



# Assemblies #
Add-Type -TypeDefinition $source -ReferencedAssemblies "System.Drawing"
Add-Type -TypeDefinition $source -ReferencedAssemblies "System.Windows.Forms"



# Effects #
$BorderFixedSimple = [System.Windows.Forms.FormBorderStyle]::FixedSingle
$FlatButton = [System.Windows.Forms.FlatStyle]::Flat
$PopButton = [System.Windows.Forms.FlatStyle]::Standard



# Cursors #
$AppStartingCursor = [System.Windows.Forms.Cursors]::AppStarting
$ArrowCursor = [System.Windows.Forms.Cursors]::Arrow
$CrossCursor = [System.Windows.Forms.Cursors]::Cross
$DefaultCursor = [System.Windows.Forms.Cursors]::Default
$HandCursor = [System.Windows.Forms.Cursors]::Hand
$HelpCursor = [System.Windows.Forms.Cursors]::Help
$HSplitCursor = [System.Windows.Forms.Cursors]::HSplit
$IBeamCursor = [System.Windows.Forms.Cursors]::IBeam
$NoCursor = [System.Windows.Forms.Cursors]::No
$NoMove2DCursor = [System.Windows.Forms.Cursors]::NoMove2D
$NoMoveHorizCursor = [System.Windows.Forms.Cursors]::NoMoveHoriz
$NoMoveVertCursor = [System.Windows.Forms.Cursors]::NoMoveVert
$PanEastCursor = [System.Windows.Forms.Cursors]::PanEast
$PanNECursor = [System.Windows.Forms.Cursors]::PanNE
$PanNorthCursor = [System.Windows.Forms.Cursors]::PanNorth
$PanNWCursor = [System.Windows.Forms.Cursors]::PanNW
$PanSECursor = [System.Windows.Forms.Cursors]::PanSE
$PanSouthCursor = [System.Windows.Forms.Cursors]::PanSouth
$PanSWCursor = [System.Windows.Forms.Cursors]::PanSW
$PanWestCursor = [System.Windows.Forms.Cursors]::PanWest
$SizeAllCursor = [System.Windows.Forms.Cursors]::SizeAll
$SizeNESWCursor = [System.Windows.Forms.Cursors]::SizeNESW
$SizeNSCursor = [System.Windows.Forms.Cursors]::SizeNS
$SizeNWSECursor = [System.Windows.Forms.Cursors]::SizeNWSE
$SizeWECursor = [System.Windows.Forms.Cursors]::SizeWE
$UpArrowCursor = [System.Windows.Forms.Cursors]::UpArrow
$VSplitCursor = [System.Windows.Forms.Cursors]::VSplit
$WaitCursor = [System.Windows.Forms.Cursors]::WaitCursor



# Jargon #
$CurrentIdentity = [Security.Principal.WindowsPrincipal][Security.Principal.WindowsIdentity]::GetCurrent()
$HostName = [System.Net.Dns]::GetHostName()



# Folders & Files #
$IconsFolder = "" + $PSScriptRoot + "\icons\"
$BatchFileLocation = $PSScriptRoot + "\test.bat"
$CurrentUserAppTextFile = $PSScriptRoot + "\test_currentuser_" + $HostName + ".txt"
$AllUserAppTextFile = $PSScriptRoot + "\test_alluser_" + $HostName + ".txt"
$AppTextFiles = $PSScriptRoot + "\test_*_" + $HostName + ".txt"
$WSResetIcon = [system.drawing.icon]::ExtractAssociatedIcon("C:\Windows\System32\WSReset.exe")



# Easier Alignment #
$R1C1 = New-Object System.Drawing.Size(0,0)
$R1C2 = New-Object System.Drawing.Size(64,0)
$R1C3 = New-Object System.Drawing.Size(128,0)
$R1C4 = New-Object System.Drawing.Size(192,0)
$R1C5 = New-Object System.Drawing.Size(256,0)
$R1C6 = New-Object System.Drawing.Size(320,0)
$R1C7 = New-Object System.Drawing.Size(384,0)
$R1C8 = New-Object System.Drawing.Size(448,0)
$R1C9 = New-Object System.Drawing.Size(512,0)
$R1C10 = New-Object System.Drawing.Size(576,0)

$R2C1 = New-Object System.Drawing.Size(0,64)
$R2C2 = New-Object System.Drawing.Size(64,64)
$R2C3 = New-Object System.Drawing.Size(128,64)
$R2C4 = New-Object System.Drawing.Size(192,64)
$R2C5 = New-Object System.Drawing.Size(256,64)
$R2C6 = New-Object System.Drawing.Size(320,64)
$R2C7 = New-Object System.Drawing.Size(384,64)
$R2C8 = New-Object System.Drawing.Size(448,64)
$R2C9 = New-Object System.Drawing.Size(512,64)
$R2C10 = New-Object System.Drawing.Size(576,64)

$R3C1 = New-Object System.Drawing.Size(0,128)
$R3C2 = New-Object System.Drawing.Size(64,128)
$R3C3 = New-Object System.Drawing.Size(128,128)
$R3C4 = New-Object System.Drawing.Size(192,128)
$R3C5 = New-Object System.Drawing.Size(256,128)
$R3C6 = New-Object System.Drawing.Size(320,128)
$R3C7 = New-Object System.Drawing.Size(384,128)
$R3C8 = New-Object System.Drawing.Size(448,128)
$R3C9 = New-Object System.Drawing.Size(512,128)
$R3C10 = New-Object System.Drawing.Size(576,128)

$R4C1 = New-Object System.Drawing.Size(0,192)
$R4C2 = New-Object System.Drawing.Size(64,192)
$R4C3 = New-Object System.Drawing.Size(128,192)
$R4C4 = New-Object System.Drawing.Size(192,192)
$R4C5 = New-Object System.Drawing.Size(256,192)
$R4C6 = New-Object System.Drawing.Size(320,192)
$R4C7 = New-Object System.Drawing.Size(384,192)
$R4C8 = New-Object System.Drawing.Size(448,192)
$R4C9 = New-Object System.Drawing.Size(512,192)
$R4C10 = New-Object System.Drawing.Size(576,192)

$R5C1 = New-Object System.Drawing.Size(0,256)
$R5C2 = New-Object System.Drawing.Size(64,256)
$R5C3 = New-Object System.Drawing.Size(128,256)
$R5C4 = New-Object System.Drawing.Size(192,256)
$R5C5 = New-Object System.Drawing.Size(256,256)
$R5C6 = New-Object System.Drawing.Size(320,256)
$R5C7 = New-Object System.Drawing.Size(384,256)
$R5C8 = New-Object System.Drawing.Size(448,256)
$R5C9 = New-Object System.Drawing.Size(512,256)
$R5C10 = New-Object System.Drawing.Size(576,256)

$R6C1 = New-Object System.Drawing.Size(0,320)
$R6C2 = New-Object System.Drawing.Size(64,320)
$R6C3 = New-Object System.Drawing.Size(128,320)
$R6C4 = New-Object System.Drawing.Size(192,320)
$R6C5 = New-Object System.Drawing.Size(256,320)
$R6C6 = New-Object System.Drawing.Size(320,320)
$R6C7 = New-Object System.Drawing.Size(384,320)
$R6C8 = New-Object System.Drawing.Size(448,320)
$R6C9 = New-Object System.Drawing.Size(512,320)
$R6C10 = New-Object System.Drawing.Size(576,320)

$R6hC1 = New-Object System.Drawing.Size(0,352)
$R6hC2 = New-Object System.Drawing.Size(64,352)
$R6hC3 = New-Object System.Drawing.Size(128,352)
$R6hC4 = New-Object System.Drawing.Size(192,352)
$R6hC5 = New-Object System.Drawing.Size(256,352)
$R6hC6 = New-Object System.Drawing.Size(320,352)
$R6hC7 = New-Object System.Drawing.Size(384,352)
$R6hC8 = New-Object System.Drawing.Size(448,352)
$R6hC9 = New-Object System.Drawing.Size(512,352)
$R6hC10 = New-Object System.Drawing.Size(576,352)

$R7C1 = New-Object System.Drawing.Size(0,384)
$R7C2 = New-Object System.Drawing.Size(64,384)
$R7C3 = New-Object System.Drawing.Size(128,384)
$R7C4 = New-Object System.Drawing.Size(192,384)
$R7C5 = New-Object System.Drawing.Size(256,384)
$R7C6 = New-Object System.Drawing.Size(320,384)
$R7C7 = New-Object System.Drawing.Size(384,384)
$R7C8 = New-Object System.Drawing.Size(448,384)
$R7C9 = New-Object System.Drawing.Size(512,384)
$R7C10 = New-Object System.Drawing.Size(576,384)

$R7hC1 = New-Object System.Drawing.Size(0,416)
$R7hC2 = New-Object System.Drawing.Size(64,416)
$R7hC3 = New-Object System.Drawing.Size(128,416)
$R7hC4 = New-Object System.Drawing.Size(192,416)
$R7hC5 = New-Object System.Drawing.Size(256,416)
$R7hC6 = New-Object System.Drawing.Size(320,416)
$R7hC7 = New-Object System.Drawing.Size(384,416)
$R7hC8 = New-Object System.Drawing.Size(448,416)
$R7hC9 = New-Object System.Drawing.Size(512,416)
$R7hC10 = New-Object System.Drawing.Size(576,416)

$R8C1 = New-Object System.Drawing.Size(0,448)
$R8C2 = New-Object System.Drawing.Size(64,448)
$R8C3 = New-Object System.Drawing.Size(128,448)
$R8C4 = New-Object System.Drawing.Size(192,448)
$R8C5 = New-Object System.Drawing.Size(256,448)
$R8C6 = New-Object System.Drawing.Size(320,448)
$R8C7 = New-Object System.Drawing.Size(384,448)
$R8C8 = New-Object System.Drawing.Size(448,448)
$R8C9 = New-Object System.Drawing.Size(512,448)
$R8C10 = New-Object System.Drawing.Size(576,448)

$R9C1 = New-Object System.Drawing.Size(0,512)
$R9C2 = New-Object System.Drawing.Size(64,512)
$R9C3 = New-Object System.Drawing.Size(128,512)
$R9C4 = New-Object System.Drawing.Size(192,512)
$R9C5 = New-Object System.Drawing.Size(256,512)
$R9C6 = New-Object System.Drawing.Size(320,512)
$R9C7 = New-Object System.Drawing.Size(384,512)
$R9C8 = New-Object System.Drawing.Size(448,512)
$R9C9 = New-Object System.Drawing.Size(512,512)
$R9C10 = New-Object System.Drawing.Size(576,512)

$R9hC1 = New-Object System.Drawing.Size(0,544)
$R9hC1h = New-Object System.Drawing.Size(32,544)
$R9hC2 = New-Object System.Drawing.Size(64,544)
$R9hC2h = New-Object System.Drawing.Size(96,544)
$R9hC3 = New-Object System.Drawing.Size(128,544)
$R9hC3h = New-Object System.Drawing.Size(160,544)
$R9hC4 = New-Object System.Drawing.Size(192,544)
$R9hC4h = New-Object System.Drawing.Size(224,544)
$R9hC5 = New-Object System.Drawing.Size(256,544)
$R9hC5h = New-Object System.Drawing.Size(288,544)
$R9hC6 = New-Object System.Drawing.Size(320,544)
$R9hC6h = New-Object System.Drawing.Size(352,544)
$R9hC7 = New-Object System.Drawing.Size(384,544)
$R9hC7h = New-Object System.Drawing.Size(416,544)
$R9hC8 = New-Object System.Drawing.Size(448,544)
$R9hC8h = New-Object System.Drawing.Size(480,544)
$R9hC9 = New-Object System.Drawing.Size(512,544)
$R9hC9h = New-Object System.Drawing.Size(544,544)
$R9hC10 = New-Object System.Drawing.Size(576,544)



# Form  Object #
$DefaultForm = New-Object System.Windows.Forms.Form
# Window Border #
$DefaultForm.FormBorderStyle = $BorderFixedSimple
# Window Position #
$DefaultForm.StartPosition = "CenterScreen"
# Window State #
$DefaultForm.WindowState = "Normal"
# Window Position #
$DefaultForm.Topmost = $True
# Window Position Not Eternal #
$DefaultForm.Topmost = $False
# Window Size #
$DefaultForm.Size = New-Object System.Drawing.Size(656,680)
# Window Title #
$DefaultForm.Text = "Windows 10 App Manager - Made With Love By MarioMasta64"
# Window Icon #
$DefaultForm.Icon = $WSResetIcon
# Window Disable Closing Window #
$DefaultForm.Add_FormClosing({$_.Cancel=$True})
# Window Disable Minimize Window #
$DefaultForm.MinimizeBox = $False
# Window Disable Maximize Window #
$DefaultForm.MaximizeBox = $False
# Window Disable Resizing Window #
$DefaultForm.SizeGripStyle = "Hide"
# Box Object #
$DefaultGroupBox = New-Object System.Windows.Forms.GroupBox
# Box Position #
$DefaultGroupBox.Location = New-Object System.Drawing.Size(0,0)
# Box Size #
$DefaultGroupBox.Size = New-Object System.Drawing.Size(640,608)
# Box Render #
$DefaultForm.Controls.Add($DefaultGroupBox)
# TextBox Object #
$DefaultTextBox = New-Object System.Windows.Forms.TextBox
# TextBox Position #
$DefaultTextBox.Location = New-Object System.Drawing.Size(0,608)
# TextBox Size #
$DefaultTextBox.Size = New-Object System.Drawing.Size(704,32)
# TextBox Font #
$DefaultTextBox.Font = New-Object System.Drawing.Font("Consolas", 8 ,[System.Drawing.FontStyle]::Regular)
# TextBox Allow Multiple Lines #
$DefaultTextBox.MultiLine = $True
# TextBox Text #
$DefaultTextBox.Text = "Welcome To The Windows 10 App Manager"
# TextBox Scrolling #
$DefaultTextBox.ScrollBars = "Vertical"
# TextBox Object #
$DefaultTextBox.ReadOnly = $True
# TextBox Object #
$DefaultTextBox.HideSelection = $False
# TextBox Render #
$DefaultForm.Controls.Add($DefaultTextBox)



# Image Locations #
$3DBuilder = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.3DBuilder.png")
$ActiproSoftwareLLC_CodeWriter = [System.Drawing.Image]::FromFile($IconsFolder + "ActiproSoftwareLLC.562882FEEB491.png")
$ButtonAppConnector = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.AppConnector.png")
$BingFinance = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.BingFinance.png")
$BingNews = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.BingNews.png")
$BingSports = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.BingSports.png")
$BingWeather = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.BingWeather.png")
$DesktopAppInstaller = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.DesktopAppInstaller.png")
$Duolingo = [System.Drawing.Image]::FromFile($IconsFolder + "D5EA27B7.Duolingo.LearnLanguagesforFree.png")
$EclipseManager = [System.Drawing.Image]::FromFile($IconsFolder + "46928bounde.EclipseManager.png")
$GetHelp = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.GetHelp.png")
$GetStarted = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.GetStarted.png")
$Messaging = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.Messaging.png")
$Microsoft3DViewer = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.Microsoft3DViewer.png")
$MicrosoftHoloLens = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.MicrosoftHoloLens.png")
$MicrosoftOfficeHub = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.MicrosoftOfficeHub.png")
$MicrosoftSolitaireCollection = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.MicrosoftSolitaireCollection.png")
$MicrosoftStickyNotes = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.MicrosoftStickyNotes.png")
$MixedRealityPortal = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.MixedReality.Portal.png")
$MSPaint = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.MSPaint.png")
$NetworkSpeedTest = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.NetworkSpeedTest.png")
$OfficeOneNote = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.Office.OneNote.png")
$OfficeSway = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.Office.Sway.png")
$OneConnect = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.OneConnect.png")
$PandoraMediaInc_Pandora = [System.Drawing.Image]::FromFile($IconsFolder + "PandoraMediaInc.29680B314EFC2.png")
$People = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.People.png")
$PhototasticCollage = [System.Drawing.Image]::FromFile($IconsFolder + "ThumbmunkeysLtd.PhototasticCollage.png")
$Print3D = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.Print3D.png")
$RemoteDesktop = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.RemoteDesktop.png")
$ScreenSketch = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.ScreenSketch.png")
$StorePurchaseApp = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.StorePurchaseApp.png")
$SkypeApp = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.SkypeApp.png")
$Wallet = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.Wallet.png")
$WindowsAlarm = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.WindowsAlarms.png")
$WindowsCalculator = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.WindowsCalculator.png")
$WindowsCamera = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.WindowsCamera.png")
$WindowsCommunicationsApps = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.WindowsCommunicationsApps.png")
$WindowsCommunicationsApps_Calendar = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.WindowsCommunicationsApps_Calendar.png")
$WindowsCommunicationsApps_Mail = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.WindowsCommunicationsApps_Mail.png")
$WindowsFeedbackHub = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.WindowsFeedbackHub.png")
$WindowsMaps = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.WindowsMaps.png")
$WindowsPhotos = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.Windows.Photos.png")
$WindowsSoundRecorder = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.WindowsSoundRecorder.png")
$WindowsStore = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.WindowsStore.png")
$XboxApp = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.XboxApp.png")
$XboxGameOverlay = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.XboxGameOverlay.png")
$YourPhone = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.YourPhone.png")
$ZuneMusic = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.ZuneMusic.png")
$ZuneVideo = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.ZuneVideo.png")

$HEIFImageExtension = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.HEIFImageExtension.png")
$MPEG2VideoExtension = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.MPEG2VideoExtension.png")
$VP9VideoExtensions = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.VP9VideoExtensions.png")
$WebMediaExtensions = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.WebMediaExtensions.png")
$WebpImageExtension = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.WebpImageExtension.png")

$QuickAssist = [System.Drawing.Image]::FromFile($IconsFolder + "App.Support.QuickAssist.png")

$DefaultImage = [System.Drawing.Image]::FromFile($IconsFolder + "default.png")
$ExtensionsImage = [System.Drawing.Image]::FromFile($IconsFolder + "plugin.png")



Function Redraw {

	# Add Quick Assist & Options Info Stuff ??? #	
	CheckInstalledApps

	$LocationApp1 = $R1C1; $SizeApp1 = $R2C2; $ImageApp1 = $3DBuilder; $PatternApp1 = "3DBuilder"; $NameApp1 = "3D Builder"; DrawButton "App1"
	$LocationApp2 = $R1C2; $SizeApp2 = $R2C2; $ImageApp2 = $WindowsAlarm; $PatternApp2 = "Alarm"; $NameApp2 = "Alarms && Clock"; DrawButton "App2"
	$LocationApp3 = $R1C3; $SizeApp3 = $R2C2; $ImageApp3 = $DefaultImage; $PatternApp3 = "AppConnector"; $NameApp3 = "App Connector"; DrawButton "App3"
	$LocationApp4 = $R1C4; $SizeApp4 = $R2C2; $ImageApp4 = $DesktopAppInstaller; $PatternApp4 = "AppInstaller"; $NameApp4 = "App Installer"; DrawButton "App4"
	$LocationApp5 = $R1C5; $SizeApp5 = $R2C3; $ImageApp5 = $WindowsCommunicationsApps; $PatternApp5 = "CommunicationsApps"; $NameApp5 = "Calendar and Mail"; DrawButton "App5"
	# $LocationApp6 = $R1C6; $SizeApp6 = $R2C2; $ImageApp6 = $DefaultImage; $PatternApp6 = ""; $NameApp6 = ""; DrawButton "App6"
	$LocationApp7 = $R1C7; $SizeApp7 = $R2C2; $ImageApp7 = $WindowsCalculator; $PatternApp7 = "Calculator"; $NameApp7 = "Calculator"; DrawButton "App7"
	$LocationApp8 = $R1C8; $SizeApp8 = $R2C2; $ImageApp8 = $WindowsCamera; $PatternApp8 = "Camera"; $NameApp8 = "Camera"; DrawButton "App8"
	$LocationApp9 = $R1C9; $SizeApp9 = $R2C2; $ImageApp9 = $WindowsFeedbackHub; $PatternApp9 = "Feedback"; $NameApp9 = "Feedback Hub"; DrawButton "App9"
	$LocationApp10 = $R1C10; $SizeApp10 = $R2C2; $ImageApp10 = $GetHelp; $PatternApp10 = "GetHelp"; $NameApp10 = "Get Help"; DrawButton "App10"
	$LocationApp11 = $R2C1; $SizeApp11 = $R2C2; $ImageApp11 = $MicrosoftOfficeHub; $PatternApp11 = "OfficeHub"; $NameApp11 = "Office"; DrawButton "App11"
	$LocationApp12 = $R2C2; $SizeApp12 = $R2C2; $ImageApp12 = $GetStarted; $PatternApp12 = "GetStarted"; $NameApp12 = "Get Started"; DrawButton "App12"
	$LocationApp13 = $R2C3; $SizeApp13 = $R2C2; $ImageApp13 = $SkypeApp; $PatternApp13 = "SkypeApp"; $NameApp13 = "Get Skype"; DrawButton "App13"
	$LocationApp14 = $R2C4; $SizeApp14 = $R2C2; $ImageApp14 = $ZuneMusic; $PatternApp14 = "ZuneMusic"; $NameApp14 = "Groove Music"; DrawButton "App14"
	$LocationApp15 = $R2C5; $SizeApp15 = $R2C2; $ImageApp15 = $WindowsMaps; $PatternApp15 = "Maps"; $NameApp15 = "Maps"; DrawButton "App15"
	$LocationApp16 = $R2C6; $SizeApp16 = $R2C2; $ImageApp16 = $Messaging; $PatternApp16 = "Messaging"; $NameApp16 = "Messaging and Skype Video"; DrawButton "App16"
	$LocationApp17 = $R2C7; $SizeApp17 = $R2C2; $ImageApp17 = $MicrosoftSolitaireCollection; $PatternApp17 = "SolitaireCollection"; $NameApp17 = "Microsoft Solitaire Collection"; DrawButton "App17"
	$LocationApp18 = $R2C8; $SizeApp18 = $R2C2; $ImageApp18 = $Wallet; $PatternApp18 = "Wallet"; $NameApp18 = "Microsoft Wallet"; DrawButton "App18"
	$LocationApp19 = $R2C9; $SizeApp19 = $R2C2; $ImageApp19 = $DefaultImage; $PatternApp19 = "ConnectivityStore"; $NameApp19 = "Microsoft Wi-Fi"; DrawButton "App19"
	$LocationApp20 = $R2C10; $SizeApp20 = $R2C2; $ImageApp20 = $MixedRealityPortal; $PatternApp20 = "MixedReality"; $NameApp20 = "Mixed Reality"; DrawButton "App20"
	$LocationApp21 = $R3C1; $SizeApp21 = $R2C2; $ImageApp21 = $BingFinance; $PatternApp21 = "BingFinance"; $NameApp21 = "Money"; DrawButton "App21"
	$LocationApp22 = $R3C2; $SizeApp22 = $R2C2; $ImageApp22 = $ZuneVideo; $PatternApp22 = "ZuneVideo"; $NameApp22 = "Movies && TV"; DrawButton "App22"
	$LocationApp23 = $R3C3; $SizeApp23 = $R2C2; $ImageApp23 = $OfficeOneNote; $PatternApp23 = "OneNote"; $NameApp23 = "OneNote"; DrawButton "App23"
	$LocationApp24 = $R3C4; $SizeApp24 = $R2C2; $ImageApp24 = $OneConnect; $PatternApp24 = "OneConnect"; $NameApp24 = "Paid Wi-Fi && Cellular"; DrawButton "App24"
	$LocationApp25 = $R3C5; $SizeApp25 = $R2C2; $ImageApp25 = $MSPaint; $PatternApp25 = "MSPaint"; $NameApp25 = "Paint 3D"; DrawButton "App25"
	$LocationApp26 = $R3C6; $SizeApp26 = $R2C2; $ImageApp26 = $People; $PatternApp26 = "Microsoft.People"; $NameApp26 = "People"; DrawButton "App26"
	$LocationApp27 = $R3C7; $SizeApp27 = $R2C2; $ImageApp27 = $DefaultImage; $PatternApp27 = "CommsPhone"; $NameApp27 = "Phone"; DrawButton "App27"
	$LocationApp28 = $R3C8; $SizeApp28 = $R2C3; $ImageApp28 = $YourPhone; $PatternApp28 = "YourPhone"; $NameApp28 = "Your Phone"; DrawButton "App28"
	# $LocationApp29 = $R3C9; $SizeApp29 = $R2C2; $ImageApp29 = $DefaultImage; $PatternApp29 = ""; $NameApp29 = ""; DrawButton "App29"
	$LocationApp32 = $R3C10; $SizeApp32 = $R2C2; $ImageApp32 = $ScreenSketch; $PatternApp32 = "ScreenSketch"; $NameApp32 = "Snip && Sketch"; DrawButton "App32"
	$LocationApp30 = $R4C1; $SizeApp30 = $R2C3; $ImageApp30 = $WindowsPhotos; $PatternApp30 = "Photos"; $NameApp30 = "Photos and Video Editor"; DrawButton "App30"
	# $LocationApp31 = $R4C2; $SizeApp31 = $R2C2; $ImageApp31 = $DefaultImage; $PatternApp31 = ""; $NameApp31 = ""; DrawButton "App31"
	$LocationApp33 = $R4C3; $SizeApp33 = $R2C2; $ImageApp33 = $BingSports; $PatternApp33 = "BingSports"; $NameApp33 = "Sports"; DrawButton "App33"
	$LocationApp34 = $R4C4; $SizeApp34 = $R2C2; $ImageApp34 = $MicrosoftStickyNotes; $PatternApp34 = "StickyNotes"; $NameApp34 = "Sticky Notes"; DrawButton "App34"
	$LocationApp35 = $R4C5; $SizeApp35 = $R2C2; $ImageApp35 = $Microsoft3DViewer; $PatternApp35 = "3DViewer"; $NameApp35 = "3D Viewer"; DrawButton "App35"
	$LocationApp36 = $R4C6; $SizeApp36 = $R2C2; $ImageApp36 = $Print3D; $PatternApp36 = "Print3D"; $NameApp36 = "Print 3D"; DrawButton "App36"
	$LocationApp37 = $R4C7; $SizeApp37 = $R2C2; $ImageApp37 = $WindowsSoundRecorder; $PatternApp37 = "SoundRecorder"; $NameApp37 = "Voice Recorder"; DrawButton "App37"
	$LocationApp38 = $R4C8; $SizeApp38 = $R2C2; $ImageApp38 = $BingWeather; $PatternApp38 = "BingWeather"; $NameApp38 = "Weather"; DrawButton "App38"
	$LocationApp39 = $R4C9; $SizeApp39 = $R2C2; $ImageApp39 = $MicrosoftHoloLens; $PatternApp39 = "Holo"; $NameApp39 = "Microsoft HoloLens"; DrawButton "App39"
	$LocationApp42 = $R4C10; $SizeApp42 = $R2C2; $ImageApp42 = $XboxGameOverlay; $PatternApp42 = "Overlay"; $NameApp42 = "Xbox Game Overlay"; DrawButton "App42"
	$LocationApp40 = $R5C1; $SizeApp40 = $R2C3; $ImageApp40 = $XboxApp; $PatternApp40 = "XboxApp"; $NameApp40 = "Xbox Console Companion"; DrawButton "App40"
	# $LocationApp41 = $R4C2; $SizeApp41 = $R2C2; $ImageApp41 = $DefaultImage; $PatternApp41 = ""; $NameApp41 = ""; DrawButton "App41"
	$LocationApp43 = $R5C3; $SizeApp43 = $R2C2; $ImageApp43 = $WindowsStore; $PatternApp43 = "WindowsStore"; $NameApp43 = "Windows Store"; DrawButton "App43"

	$LocationExtension1 = $R5C4; $SizeExtension1 = $R2C2; $ImageExtension1 = "none"; $PatternExtension1 = "HEIFImageExtension"; $NameExtension1 = "Heif Image"; DrawButton "Extension1"
	$LocationExtension2 = $R5C5; $SizeExtension2 = $R2C2; $ImageExtension2 = "none"; $MPEG2VideoExtension; $PatternExtension2 = "MPEG2VideoExtension"; $NameExtension2 = "MPEG-2 Video"; DrawButton "Extension2"
	$LocationExtension3 = $R5C6; $SizeExtension3 = $R2C2; $ImageExtension3 = "none"; $VP9VideoExtensions; $PatternExtension3 = "VP9VideoExtensions"; $NameExtension3 = "VP9 Video"; DrawButton "Extension3"
	$LocationExtension4 = $R5C7; $SizeExtension4 = $R2C2; $ImageExtension4 = "none"; $WebMediaExtensions; $PatternExtension4 = "WebMediaExtensions"; $NameExtension4 = "Web Media"; DrawButton "Extension4"
	$LocationExtension5 = $R5C8; $SizeExtension5 = $R2C2; $ImageExtension5 = "none"; $WebpImageExtension; $PatternExtension5 = "WebpImageExtension"; $NameExtension5 = "WebP Image"; DrawButton "Extension5"

	$LocationBloatware1 = $R5C9; $SizeBloatware1 = $R2C2; $ImageBloatware1 = "none"; $PatternBloatware1 = "Advertising"; $NameBloatware1 = "Advertising"; DrawButton "Bloatware1"

	$LocationExtra1 = $R6hC1; $SizeExtra1 = $R2C2; $ImageExtra1 = $BingNews; $PatternExtra1 = "BingNews"; $NameExtra1 = "News"; DrawButton "Extra1"
	$LocationExtra2 = $R6hC2; $SizeExtra2 = $R2C2; $ImageExtra2 = $OfficeSway; $PatternExtra2 = "Sway"; $NameExtra2 = "Sway"; DrawButton "Extra2"
	$LocationExtra3 = $R6hC3; $SizeExtra3 = $R2C2; $ImageExtra3 = $RemoteDesktop; $PatternExtra3 = "RemoteDesktop"; $NameExtra3 = "Remote Desktop"; DrawButton "Extra3"
	$LocationExtra4 = $R6hC4; $SizeExtra4 = $R2C2; $ImageExtra4 = $Duolingo; $PatternExtra4 = "Duolingo"; $NameExtra4 = "Duolingo"; DrawButton "Extra4"
	$LocationExtra5 = $R6hC5; $SizeExtra5 = $R2C2; $ImageExtra5 = $EclipseManager; $PatternExtra5 = "EclipseManager"; $NameExtra5 = "Eclipse Manager"; DrawButton "Extra5"
	$LocationExtra6 = $R6hC6; $SizeExtra6 = $R2C2; $ImageExtra6 = $ActiproSoftwareLLC_CodeWriter; $PatternExtra6 = "ActiproSoftwareLLC.562882FEEB491"; $NameExtra6 = "Code Writer"; DrawButton "Extra6"
	$LocationExtra7 = $R6hC7; $SizeExtra7 = $R2C2; $ImageExtra7 = $NetworkSpeedTest; $PatternExtra7 = "NetworkSpeedTest"; $NameExtra7 = "Network Speed Test"; DrawButton "Extra7"
	$LocationExtra8 = $R6hC8; $SizeExtra8 = $R2C2; $ImageExtra8 = $PandoraMediaInc_Pandora; $PatternExtra8 = "PandoraMediaInc.29680B314EFC2"; $NameExtra8 = "Pandora"; DrawButton "Extra8"
	$LocationExtra9 = $R6hC9; $SizeExtra9 = $R2C2; $ImageExtra9 = $PhototasticCollage; $PatternExtra9 = "PhototasticCollage"; $NameExtra9 = "Phototastic Collage"; DrawButton "Extra9"

	Return

}

Function OutputText {
    Param ($Message)
    $DefaultTextBox.AppendText("$Message")
    $DefaultTextBox.Refresh()
    $DefaultTextBox.ScrollToCaret()
	Return
}

Function CheckInstalledApps {
	Waiting
	Remove-Item .\*.txt
	Get-AppxPackage | ft Name -AutoSize | Out-File -FilePath .\current.txt
	Get-AppxPackage -AllUsers | ft Name -AutoSize | Out-File -FilePath .\all.txt
	Ready
	Return
}
Function UninstallApp {
	Waiting
	Get-AppxPackage *$args* | Foreach {
		OutputText -Message "`r`nUninstalling $_"
		Remove-AppxPackage "$_"
		OutputText -Message " - Done"
	}
	Ready
	Return
}
Function ReinstallApp {
	Waiting
	Get-AppxPackage -AllUsers *$args* | Foreach {
		OutputText -Message "`r`nReinstalling $_"
		Add-AppxPackage -DisableDevelopmentMode -Register "$($_.InstallLocation)\AppXManifest.xml"
		OutputText -Message " - Done"
	}
	Ready
	Reload
	Return
}
Function UninstallAll {
	Waiting
	KillExplorer
	Get-AppxPackage | Foreach {
		OutputText -Message "`r`nUninstalling $_"
		Remove-AppxPackage "$_"
		OutputText -Message " - Done"
	}
	StartExplorer
	Ready
	ReloadPowerShellFile
	Return
}
Function ReinstallAll {
	Waiting
	KillExplorer
	Get-AppxPackage -AllUsers | Foreach {
		OutputText -Message "`r`nReinstalling $_"
		Add-AppxPackage -DisableDevelopmentMode -Register "$($_.InstallLocation)\AppXManifest.xml"
		OutputText -Message " - Done"
	}
	StartExplorer
	Ready
	ReloadPowerShellFile
	Return
}

Function OpenStartMenu { Waiting; [KeyboardSend.KeyboardSend]::KeyDown("LWin"); [KeyboardSend.KeyboardSend]::KeyUp("LWin"); Ready; Return }
Function KillExplorer { Waiting; & cmd /c `"taskkill /f /im explorer.exe`"; Ready; Return }
Function StartExplorer { Waiting; & explorer.exe; Ready; Return }
Function ExitClean { AppStarting; [environment]::exit(0); Return }

Function ReloadPowerShellFile { Waiting; & $BatchFileLocation; ExitClean; Return }
Function BecomeAdmin { Waiting; Start-Process powershell.exe "-Windowstyle Hidden -NoProfile -ExecutionPolicy Bypass -File `"$PSCommandPath`"" -Verb RunAs; ExitClean; Return }

Function Waiting { $DefaultForm.Cursor = $WaitCursor; Return }
Function AppStarting { $DefaultForm.Cursor = $AppStarting; Return }
Function Ready { $DefaultForm.Cursor = $Default; Return }

Function DrawButton {

	# Import Button Data #
	$Temp = "$args"
	$LocationType = Get-Variable -Name "Location$Temp" -Value
	$SizeType = Get-Variable -Name "Size$Temp" -Value
	$ImageType = Get-Variable -Name "Image$Temp" -Value
	$PatternType = Get-Variable -Name "Pattern$Temp" -Value
	$NameType = Get-Variable -Name "Name$Temp" -Value

	# Make Button Object #
	$ButtonType = New-Object System.Windows.Forms.Button
	
	# Store Variables
    $ButtonType | Add-Member -NotePropertyMembers @{ LocationTemp = $LocationType }
    $ButtonType | Add-Member -NotePropertyMembers @{ SizeTemp = $SizeType }
    $ButtonType | Add-Member -NotePropertyMembers @{ ImageTemp = $ImageType }
    $ButtonType | Add-Member -NotePropertyMembers @{ PatternTemp = $PatternType }
    $ButtonType | Add-Member -NotePropertyMembers @{ NameTemp = $NameType }

	# Button Stuff #
	$ButtonType.Location = $LocationType
	$ButtonType.Size = $SizeType
	if ("$ImageType" -ne "none") { $ButtonType.BackgroundImage = $ImageType } else { $ButtonType.Text = "$NameType"; $ButtonType.Image = $DefaultImage }
	$ButtonType.BackgroundImageLayout = "Zoom"
	# Note: When Inside Button Add_Click Can Use "$This" Instead Of $ButtonType
	$ButtonType.Add_Click({
	
		# Retrieve Variables
		$LocationType = "$($This.LocationTemp)"
		$SizeType = "$($This.SizeTemp)"
		$ImageType = "$($This.ImageTemp)"
		$PatternType = "$($This.PatternTemp)"
		$NameType = "$($This.NameTemp)"
		
		# Toggle Installation #
		$SEL = Get-AppxPackage *$PatternType*
		if ($SEL -ne $null) { UninstallApp "$PatternType" } else { ReinstallApp "$PatternType" }
		
		# Update Button Based On Installation Status [When Clicked] #
		$SEL = Get-AppxPackage -AllUsers *$PatternType*
		if ($SEL -eq $null) { $This.Text = "$NameType"; $This.Enabled = $False; $This.Image = $DefaultImage }
		$SEL = Get-AppxPackage *$PatternType*
		if ($SEL -eq $null) { $This.FlatStyle = $FlatButton } else { $This.FlatStyle = $PopButton }
		
		# OpenStartMenu
		
	})
	
	# Update Button Based On Installation Status [When Drawn] #
	$SEL = Get-Content .\all.txt | Select-String "$PatternType"
	if ($SEL -eq $null) { $ButtonType.Text = "$NameType"; $ButtonType.Enabled = $False; $ButtonType.Image = $DefaultImage }
	$SEL = Get-Content .\current.txt | Select-String "$PatternType"
	if ($SEL -eq $null) { $ButtonType.FlatStyle = $FlatButton } else { $ButtonType.FlatStyle = $PopButton}
	$ButtonType.Cursor = $HandCursor; $DefaultGroupBox.Controls.Add($ButtonType)
	
	Return

}



$ButtonFeatures1 = New-Object System.Windows.Forms.Button
$ButtonFeatures1.Location = $R8C1
$ButtonFeatures1.Size = $R2C2
$ButtonFeatures1.BackgroundImage = $QuickAssist
$ButtonFeatures1.BackgroundImageLayout = "Zoom"
$ButtonFeatures1.Add_Click({
	$ButtonFeatures1.Cursor = $WaitCursor
	Remove-WindowsCapability -online -name App.Support.QuickAssist~~~~0.0.1.0
	$ButtonFeatures1.Cursor = $HandCursor
	# OpenStartMenu
})
$ButtonFeatures1.Cursor = $HandCursor
$DefaultGroupBox.Controls.Add($ButtonFeatures1)

$ButtonOptions1 = New-Object System.Windows.Forms.Button
$ButtonOptions1.Location = $R9hC1
$ButtonOptions1.Size = $R2C2
$ButtonOptions1.Text = "Windows Start Menu"
$ButtonOptions1.Image = $DefaultImage
$ButtonOptions1.BackgroundImageLayout = "Zoom"
$ButtonOptions1.Add_Click({ OpenStartMenu })
$ButtonOptions1.Cursor = $HandCursor
$DefaultGroupBox.Controls.Add($ButtonOptions1)
$ButtonFeatures1.Cursor = $HandCursor
$DefaultGroupBox.Controls.Add($ButtonFeatures1)

$ButtonOptions2 = New-Object System.Windows.Forms.Button
$ButtonOptions2.Location = $R9hC2
$ButtonOptions2.Size = $R2C2
$ButtonOptions2.Text = "Restart Explorer"
$ButtonOptions2.Image = $DefaultImage
$ButtonOptions2.BackgroundImageLayout = "Zoom"
$ButtonOptions2.Add_Click({ KillExplorer; StartExplorer })
$ButtonOptions2.Cursor = $HandCursor
$DefaultGroupBox.Controls.Add($ButtonOptions2)

$ButtonOptions3 = New-Object System.Windows.Forms.Button
$ButtonOptions3.Location = $R9hC3
$ButtonOptions3.Size = $R2C2
$ButtonOptions3.Text = "Visit Website"
$ButtonOptions3.Image = $DefaultImage
$ButtonOptions3.BackgroundImageLayout = "Zoom"
$ButtonOptions3.Add_Click({ [system.Diagnostics.Process]::start("https://mariomasta64.me/") })
$ButtonOptions3.Cursor = $HandCursor
$DefaultGroupBox.Controls.Add($ButtonOptions3)

$ButtonOptions4 = New-Object System.Windows.Forms.Button
$ButtonOptions4.Location = $R9hC4h
$ButtonOptions4.Size = $R2C2
$ButtonOptions4.Text = "Currently Installed"
$ButtonOptions4.Image = $DefaultImage
$ButtonOptions4.BackgroundImageLayout = "Zoom"
$ButtonOptions4.Add_Click({
	CheckInstalledApps
    & cmd /c `"del $AppTextFiles`"
    copy .\current.txt $CurrentUserAppTextFile
    copy .\all.txt $AllUserAppTextFile
	& notepad.exe $CurrentUserAppTextFile
})
$ButtonOptions4.Cursor = $HandCursor
$DefaultGroupBox.Controls.Add($ButtonOptions4)

$ButtonOptions5 = New-Object System.Windows.Forms.Button
$ButtonOptions5.Location = $R9hC5h
$ButtonOptions5.Size = $R2C2
$ButtonOptions5.Text = "Reinstall Defaults"
$ButtonOptions5.Image = $DefaultImage
$ButtonOptions5.BackgroundImageLayout = "Zoom"
$ButtonOptions5.Add_Click({ ReinstallAll; OpenStartMenu })
$ButtonOptions5.Cursor = $HandCursor
$DefaultGroupBox.Controls.Add($ButtonOptions5)

$ButtonOptions6 = New-Object System.Windows.Forms.Button
$ButtonOptions6.Location = $R9hC6h
$ButtonOptions6.Size = $R2C2
$ButtonOptions6.Text = "Uninstall Everything"
$ButtonOptions6.Image = $DefaultImage
$ButtonOptions6.BackgroundImageLayout = "Zoom"
$ButtonOptions6.Add_Click({ UninstallAll; OpenStartMenu })
$ButtonOptions6.Cursor = $HandCursor
$DefaultGroupBox.Controls.Add($ButtonOptions6)

$ButtonOptions8 = New-Object System.Windows.Forms.Button
$ButtonOptions8.Location = $R9hC8
$ButtonOptions8.Size = $R2C2
$ButtonOptions8.Text = "Reload"
$ButtonOptions8.Image = $DefaultImage
$ButtonOptions8.BackgroundImageLayout = "Zoom"
$ButtonOptions8.Add_Click({ ReloadPowerShellFile })
$ButtonOptions8.Cursor = $HandCursor
$DefaultGroupBox.Controls.Add($ButtonOptions8)

$ButtonOptions9 = New-Object System.Windows.Forms.Button
$ButtonOptions9.Location = $R9hC9
$ButtonOptions9.Size = $R2C2
$ButtonOptions9.Image = $DefaultImage
$ButtonOptions9.BackgroundImageLayout = "Zoom"
if (!($CurrentIdentity).IsInRole([Security.Principal.WindowsBuiltInRole] "Administrator")) {
	OutputText -Message "`r`nAdmin Required Please Click On `"Become Admin`""
	$ButtonOptions9.Text = "Become Admin"
	$ButtonOptions9.Add_Click({ BecomeAdmin })
} else {
	OutputText -Message "`r`nClick An App To Toggle Its Installation"
	$ButtonOptions9.Text = "Already Admin"
	$ButtonOptions9.FlatStyle = $FlatButton
	$ButtonOptions9.Enabled = $False
}
$ButtonOptions9.Cursor = $HandCursor
$DefaultGroupBox.Controls.Add($ButtonOptions9)

$ButtonOptions10 = New-Object System.Windows.Forms.Button
$ButtonOptions10.Location = $R9hC10
$ButtonOptions10.Size = $R2C2
$ButtonOptions10.Text = "Exit"
$ButtonOptions10.Image = $DefaultImage
$ButtonOptions10.BackgroundImageLayout = "Zoom"
$ButtonOptions10.Add_Click({ ExitClean })
$ButtonOptions10.Cursor = $HandCursor
$DefaultGroupBox.Controls.Add($ButtonOptions10)



Redraw



# THANK YOU #

# https://stackoverflow.com/users/8523330/rokumaru #
# https://stackoverflow.com/users/6811411/lotpings #
# https://stackoverflow.com/questions/56502562/how-do-i-store-information-in-a-variable-name-that-contains-a-variable #

# https://stackoverflow.com/users/45375/mklement0 #
# https://stackoverflow.com/questions/56518860/expand-all-variables-inside-add-click-inside-Function/56519814#56519814 #

# https://github.com/stefanstranger #
# https://github.com/stefanstranger/PowerShell/blob/master/WinKeys.ps1 #

# https://community.idera.com/members/nohandle #
# https://community.idera.com/database-tools/powershell/powertips/b/tips/posts/launching-powershell-hidden #

# https://www.powershellbros.com/create-first-powershell-gui-tool/ #

# https://www.reddit.com/r/PowerShell/comments/7gxbc8/writehost_output_to_formstextbox/ #



$DefaultForm.Add_Shown({$DefaultForm.Activate()})
[void] $DefaultForm.ShowDialog()